/******************************************************************
*                      SectionPC Lib  v0.6 10/03/2005             *
*                              (c)2004 Mathias Kende              *
*******************************************************************
                                        
Cette librairie peut tre redistribu gratuitement et utilise dans
n'importe quel programme gratuit ou commercial (j'ai des doute qu'un
programme commercial veuille l'utiliser, mais bon...).

Vous ne pouvez pas par contre la dsassembler et/ou la dcompiler.
Tout le code compris dans cette librairie est protg par les lois
franaises et internationnalles en vigueures sur la proprit intellectuelle.

La librairie utilise le fichier d'en tte"windows.h" et l'inclut donc
automatiquement. Par consquant, si vous voulez liminez certaines
parties de "windows.h", dfinissez les constantes ncessaires avant
d'inclure ce fichier-ci.

Microsoft Visual C++ :
  Le fichier d'en tte (celui-ci) contient les directives ncessaire
  pour que le compilateur link votre programme avec "SectionPC.lib" 
  condition que ce fichier soit dans le dossier "lib" de votre compilateur.
  Pour simplifier l'utilisation, je vous conseille de mettre le fichier
  "SectionPC.h" dans le dossier "include" de votre compilateur et le
  fichier "SectionPC.lib" dans le dossier "lib" de votre compilateur.
  Ainsi pour pouvoir utilisez la librairie il vous suffira d'utiliser la
  commande :
  #include <SectionPC.h>

Bloodshed Dev C++ :
  Pour pouvoir compiler, vous devez d'abord linker votre programme avec
  "SectionPC.a". Je vous conseille de mettre aussi le fichier "SectionPC.h"
  dans le dossier "include" de votre compilateur et le fichier "SectionPC.a"
  dans le dosssier "lib" de votre compilateur. Pour utilisez la libairie,
  utiliser la commande :
  #include <SectionPC.h>
  Et linker votre programme avec la librairie. Pour cela avec Dev C++ allez
  dans option du projet (alt+P) onglet "paramtres" puis sous la case 
  "diteur de lien", cliquez sur ajouter un fichier et slectionnez le
  fichier "SectionPC.a".
  
  De plus, le fichier d'en tte "shlobj.h" tel qu'il est fourni avec Dev C++
  version 4.9.9.0 et peut-tre d'autre version est incomplet. Si vous obtenez
  des erreurs  la compilation de "SectionPC.h" disant que certaine constante
  ne sont pas dfinies, remplacez dans le dossier "include" de Dev C++ le fichier
  "shlobj.h" par celui qui est fourni dans le zip. Si vous possdez une version
  plus rcente que celle mentionn plus haut et que vous ne voulez pas remplac
  le fichier ou bien que son remplacement provoque d'autres erreurs (j'espre
  que vous avez fait une copie de sauvegarde), vous pouvez tout simplement
  rajoutter ces 3 lignes  la place qui vous semblera logique dans le fichier
  (plutt vers le dbut) :
  #define CSIDL_MYDOCUMENTS 12
  #define CSIDL_MYMUSIC 13
  #define CSIDL_MYVIDEO 14

NOTE sur la mentalit de cette librairie :
  La gestion d'erreur effectu en interne par la librairie couvre les problmes
  que l'on ne peut pas prvoir (le presse papier est utilis par une autre
  application, le buffer est trop petit pour terminer une opration, etc.).
  Par contre il n'y a AUCUNE gestion des erreurs qui pourrait tre commises
  en amont de ce code : si vous passez un pointeur vers une variable tampon
  (buffer) et que vous indiquez une taille suprieur  la ralit alors une
  exception a de gros risque de se produire et la librairie n'y fera rien.
  Mais je rappelle encore une fois que si vous donnez un buffer trop petit
  mais que vous indiquez sa taille relle, il n'y aura aucun problme. J'ai
  adopt cette politique, car controller ce genre d'erreur est beacoup plus
  facile en amont et a permet de gagner beaucoup de temps  l'excution.

Systmes antrieurs  Windows 2000 :
  Pour toute les versions de windows antrieur  windows 2000 (95, 98, 98SE, ME, NT)
  La fonction GetDir du namespace win32 necessite la DLL "shfolder.dll" non
  seulement  la compilation (si celle ci se fait sur une machine non quip de
  windows 2000 ou XP) mais aussi  l'excution. Vous devez donc (et pouvez librement
  le faire) redistribuez cette DLL avec votre application si celle-ci est
  susceptible d'tre excut sur l'un des systme d'exploitation sus-nomms.
  Si vous ne possdez pas cette DLL, vous pouvez la tlecharger sur mon site :
  http://perso.wanadoo.fr/sectionpc/lib Tlchargez ShFolder.zip pour excutez le
  programme contenu dans le zip. Vous pouvez en trouvez une version  jour sur le
  site de microsoft.
  

                                 Bug

 Dans SectionPC::Hash la fonction md5 ne marche pas compltement.
 Dans SectionPC::win32 la fonction SendKeys ne marche pas du tout.
        (Dans SectionPC::win32::Chrono il faut corriger le bug qui arrivera
corrig-{immanquablement si jamais il y a plus de 4 milliard de compteurs crs
        (dans une mme session.

*/

#ifndef SECTIONPC
  #define SECTIONPC

#ifdef SECTIONPC_NOHEADER
  #define SECTIONPC_NOWINDOWS_H
  #define SECTIONPC_NOSHLOBJ_H
#endif

#ifndef SECTIONPC_NOWINDOWS_H
  #ifndef _WINDOWS_       //VC++
    #ifndef _WINDOWS_H      //Dev C++
      #include <windows.h>
    #endif
  #endif
#endif

#ifndef SECTIONPC_NOSHLOBJ_H
  #ifndef SECTIONPC_NOWIN32
    #ifndef _SHLOBJ_H_    //VC++
    #ifndef _SHLOBJ_H     //Dev C++
      #include <shlobj.h>
    #endif
    #endif
  #endif
#endif

#ifdef _MSC_VER   //Sur VC++
  #define USING_VCPP
  typedef unsigned __int64 SPINT64;
  typedef unsigned __int32 SPINT32;
#else             //Sur Dev C++
  #define USING_DEVCPP
  typedef unsigned long long SPINT64;
  typedef unsigned long SPINT32;
#endif

//Seul VC++ lis ceci, avec Dev c++ il faut inclure SectionPC.a manuellement.
#ifndef _SECTION_PC_    //C'est une constante dfinit lors de la compilation de la lib elle mme.
  #ifdef _DEBUG
    #ifdef SECTIONPC_DEBUGMODE  //Ne vous servez pas de cette constante, a ne sers  rien vous ne possdez par la librairie de dbug.
      #define SECTIONPC_LIB_INC 
      #pragma comment(linker,"/DEFAULTLIB:SectionPC_debug")
    #endif
  #endif
  #ifndef SECTIONPC_LIB_INC     //bug de VC++ lors de la lecture du fichier pour compilation en mode Debug
    #pragma comment(lib,"SectionPC")
  #endif
#endif

namespace SectionPC
{
/********************************************************************
*                               ASCII                               *
*********************************************************************
  Permet de convertir une chaines de caractres en une chaine form
par les codes hxadcimaux des diffrend caractres de la chaine.
BufferSize est la taille en octet de OutBuffer. Ne gre que l'ASCII. */
#ifndef SECTIONPC_NOASCII
	namespace Ascii
	{
		bool AsciiToHex(char* InStr,char* OutBuffer,int* BufferSize);
		bool HexToAscii(char* InStr,char* OutBuffer,int* BufferSize);
    bool AsciiToBin(char* InStr,char* OutBuffer,int* BufferSize);
    bool BinToAscii(char* InStr,char* OutBuffer,int* BufferSize);
    bool AsciiToHex(char* InStr,char* OutBuffer,int BufferSize);
		bool HexToAscii(char* InStr,char* OutBuffer,int BufferSize);
    bool AsciiToBin(char* InStr,char* OutBuffer,int BufferSize);
    bool BinToAscii(char* InStr,char* OutBuffer,int BufferSize);
	}
#endif
/********************************************************************
*                                HASH                               *
*********************************************************************
  Ce namespace fourni un support pour certaines fonctions de manipulation
de chaines plus lgres que celle de la stdlib. */
#ifndef SECTIONPC_NOHASH
	namespace Hash
	{
    const long CMD_QUIT=1953068401; //constante correspondant au mot quit avec la fonction hash.
		char* LCase (char* Str);         //Convertit une chaine en minuscule.
		char* UCase (char* Str);         //Convertit une chaine en Majuscule.
         /* ATTENTION : ces deux fonctions ecrivent par dessus la chaine qui
            leur est pass en argument. Si vous ne voulez pas les effacez
            utilisez conjointement la fonction StrCopy */
		long Hash(char* CMD);           //fourni un hash simple mais efficace pour gnrer des constantes  la place de chaine de caractre l o c'est utile
         /* utiliser HASH_CLI pour avoir des valeurs avant la compilation).
            La hash est case-insensitive et s'arrte lorsqu'il arrive  la
            fin de la chaines,  l'un des ces caractre : {',','=',':','.',' '}
            ou au 16ime caractre. utile lorsque vous attendez des mots bien
            dfinie entr par l'utilisateur et que vous voulez utilisez un switch. 
            De plus cette fonction tout comme les fonction prcdente modifie la
            chaine qui lui est pass en argument. */
		long Val(char *Nb);		          //identique  ValLong, gard pour des raison de retro-compatibilit.
		long ValLong(char *Nb);         //convertit une chaine de caractre en long (atol)
		double ValDouble(char *Nb);     //convertit une chaine de caractre en double (atof)
		long StrLen(const char *Nb);          //Renvoie le nombre de caractre d'une chaine SANS compter le 0 final.
		long Str(signed long Nb,char* Buffer,long Len); //Idem que StrLong
		long StrLong(signed long Nb,    //Un nombre  convertir en chaine de caractre (itoa)
                 char* Buffer,      //Pointeur vers une zone de mmoire initialis pour la chaine de retour
                 long Len);         //Taille totale du buffer.
		long StrLong(__int64 Nb,char* Buffer,long Len); //Je ne vous recommende pas d'utiliser cette fonction. Elel devrait marcher, mais j'ai eu des problme quand mme avec.
		long StrLong(unsigned long Nb,char* Buffer,long Len); //le buffer peut tre un tout petit peu plus petit
		long StrCopy(char *In,          //Pointeur vers la chaine  copier (termin par un 0).
                 char *Out,         //Pointeur vers al zone mmoire o copier la chaine
                 long Size);        //Taille du buffer de sortie.
         /* Renvoie le nombre totale de caractre sans compter le 0 final */
    void md5(char *Texte, char Output[33]); //En phase de test, la fonction n'est pas parfaitement au point, mais est cens renvoyer un hash md5.
	}
#endif
/********************************************************************
*                             CLIPBOARD                             *
*********************************************************************
  Permet de lire des chaine (et seulement des chaines de caractres)
contenues dans le presse papier et d'en crire. */
#ifndef SECTIONPC_NOCLIPBOARD
	namespace Clipboard
	{
		bool GetClipboardText(char** Text);
         /* Renvoie false si le presse papier ne contient pas de texte
            ou s'il ne peut pas tre ouvert. */
		long GetClipboardText(char* Text,long Size);
		bool SetClipboardText(char* Text,long Size);
		bool ClearClipboard();
	}
#endif
/********************************************************************
*                                MATH                               *
*********************************************************************
  Fournit quelques fonction mathmatiques */
#ifndef SECTIONPC_NOMATH
  namespace Math
	{
    double Sqrt(double X); //Racine carr
    double Cbrt(double X); //Racine cubic
    int Signe(double X);
      #define PLUS 1
      #define MOINS -1
      #define UNDEF 0
      /* UNDEF n'est pas forcement 0, a peut aussi tre un dpassement
        de capacit dans un sens ou l'autre. */
    double Exp(double Mantisse,int Exposant);
    //double Abs(double X);
    double carre(double x);
    //double Log(double X);
    //double Ln(double X);
    double Pow(double X,int Exposant);
    double Fact(int Nb);

// Fonctions crites en ASM :
#ifndef USING_DEVCPP
    double abs(double x);
    double cos(double x);
    double sin(double x);
    double tan(double x);
    double atan(double x);
    double fmod(double x,double y);  //calcule le reste de la division de x par y 
    double sqrt(double x);
    double log10(double x);
    double log(double x);

    double SPC_pow();
    //#define pow(x,y) ( __asm {FLD y} , __asm {FLD x} , SPC_pow() )

#define pow3(x,y,l) (int (tmp ## l)=y;{__asm {FLD (tmp ## l)} tmp ## l=x; __asm {FLD tmp ## l} SPC_pow();__asm {FSTP int tmp ## l=y}};tmp ## l)
#define pow2(x,y,l) pow3(x,y,l)
#define pow(x,y) pow2(x,y,__LINE__)

#endif


    double Binome(unsigned int n,unsigned int k); //Calcule le nombre de manire de choisir k lments parmis n.
    bool IsFibonacci(int N);      //Renvoie si un nombre fait ou non partie de la suite de Fibonacci.

    namespace Suite
    {
      typedef void* LPSUITE;
      LPSUITE CreateSuite(double(*Fonc)(double,int),double X0,int n0);
        /* A l'appel de la fonction, la fonction Fonc est appeler avec comme argument
          X0 et n0 ceci pour permettre un possible paramtrage (Cf suite racine).
          Le rsultat est de toute facons oublier et X0 sera passer lorsque l'on voudra
          n0+1. De plus lorsque l'on veut n0, la fonction n'est pas appell et X0
          est renvoy automatiquement. */
      void SetX0(LPSUITE Suite,double X0);
      bool DelSuite(LPSUITE Suite);
      double EvalSuite(LPSUITE Suite,int N);
        /* Renvoie le terme N-ime de la suite.
          Donc EvalSuite(Suite,0) renvoie le terme 0 de la suite.
          Pour tout N<=n0 la fonction renvoie X0
          pour N=n0+1, la fonction renvoie Fonc(X0). */
    }
    namespace Fonctions
    {
      #define NO_SOLUTION 4.6571360213473e-287
      double nDeriv(double(&Fonc)(double),double X,double e=1e-4);
      double Integrate(double(&Fonc)(double),double xMin,double xMax,double e=1e-3);
      double Solve(double(&Fonc)(double),double xMin=-1e6,double xMax=1e6,double Approx=0,double e=1e-4);
      double AdvSolve(double(&Fonc)(double),double xMin=-1e6,double xMax=1e6,int pres=4);
      double Sum(double(&Fonc)(double),double xMin,double xMax,double Step=1);
      double Mean(double(&Fonc)(double),double xMin,double xMax,double e=1e-4);
    }
    class Complexe
    {
      public:
        Complexe();
        Complexe(double,double,bool IsPol=false); //les arguments sont dans le mme ordre que pour SetPol et SetCart
        Complexe(double Reel);                    //Cre un complexe  partir d'un nombre rel.
        double GetIm();
        double GetRe();
        double GetMod();
        double GetMod2();   //Renvoie le carr du module (plus rapide)
        double GetArg();
        void SetCart(double RePart, double ImPart);
        void SetCart();   //force la conversion en coordonnes carthsiennes.
        void SetPol(double Module,double Argument);
        void SetPol();    //force la convertion en coordonnes polaire.
        void SetRe(double Re);
        void SetIm(double Im);
        void SetMod(double Mod);
        void SetArg(double Arg);
        bool IsPolUtD();
        bool IsCartUtD();
        void Zero();
        void Oppose();
        void Inv();
        void Conj();
        void SqrPow();
        void Add(Complexe &NbC);
        void Mul(Complexe &NbC);
        void Mul(double Nb);
        Complexe operator+(Complexe &Autre);    //effectu en carthsien
        Complexe operator-(Complexe &Autre);    //effectu en carthsien
        Complexe operator*(Complexe &Autre);    //La multiplication se fait dans le systme de coordonnes du membre de gauche et par dfaut en polaire.
        Complexe operator/(Complexe &Autre);    //effectu en polaire
        Complexe &operator+=(Complexe &Autre);
        Complexe &operator-=(Complexe &Autre);
        Complexe &operator*=(Complexe &Autre);
        Complexe &operator/=(Complexe &Autre);
        Complexe SqrPow(Complexe &NbC);
        Complexe SqrRoot(Complexe &NbC);
      private:
        double Im,Re,Mod,Arg,Tmp;
        bool PolUtD,CartUtD;
    };
    class Cell
    {
      public:
        Cell();
        Cell(unsigned int Col,unsigned int Row,double Value);
        unsigned int x,y;
        double v;
    };
    class Matrice
    {
      public:
        Matrice(unsigned int NbCol,unsigned int NbRow);
        Matrice(const Matrice &Mat);
        Matrice();
        ~Matrice();

        double GetCell(unsigned int Col,unsigned int Row) const;
        bool SetCell(Cell cell);
        bool SetCell(unsigned int Col,unsigned int Row,double Value);
        Matrice &operator+=(const Matrice &Autre);
        Matrice &operator=(const Matrice &Autre);
        int GetNbRow();
        int GetNbCol();
      protected:
        unsigned int Row,Col;
        double **matrice;
    };
  }
#endif
/********************************************************************
*                              REGISTRY                             *
********************************************************************/
#ifndef SECTIONPC_NOREGISTRY
	namespace Registry
	{
    typedef unsigned long uLONG;
    namespace ERROR_TYPE
    {
      enum ERROR_TYPE_ENUM
      {
        ERROR_FAILURE,              //La fonction choue
        ERROR_NOERROR,              //La fonction russie
        ERROR_SUCCESS_CREATED,      //La fonction russie, la clef est cre
        ERROR_SUCCESS_OPENED,       //La fonction russie, la clef est ouverte
        ERROR_SUCCESS_UNKNOWN,      //La fonction russie
        ERROR_LEN_MISMATCH,         //La taille donne ne correspond pas avec celle requise.
        ERROR_NEED_LEN,             //La fonction a besoin de la taille des donnes
        ERROR_TYPE_UNKNOWN,         //Le type de donnes n'existe pas.
        ERROR_BAD_TYPE,             //Le type de donnes ne peut pas tre utilis
        ERROR_TYPE_MISMATCH         //Le type de donne sous entendu pas la fonction surcharg n'est pas celui qu'elle rcupre.
      };
    }
		namespace REG_VALUE_TYPE
		{
      enum REG_VALUE_TYPE_ENUM
      {
			  VALUE_TYPE_NONE=REG_NONE,																//No defined value type. 
			  VALUE_TYPE_SZ=REG_SZ,																		//A null-terminated string. It will be a Unicode or ANSI string, depending on whether you use the Unicode or ANSI functions.
 			  VALUE_TYPE_EXPAND_SZ=REG_EXPAND_SZ,											//A null-terminated string that contains unexpanded references to environment variables (for example, "%PATH%"). It will be a Unicode or ANSI string depending on whether you use the Unicode or ANSI functions. To expand the environment variable references, use the ExpandEnvironmentStrings function. 
			  VALUE_TYPE_BINARY=REG_BINARY,													  //Binary data in any form. 
			  VALUE_TYPE_DWORD=REG_DWORD,															//A 32-bit number. 
			  VALUE_TYPE_DWORD_LITTLE_ENDIAN=REG_DWORD_LITTLE_ENDIAN, //A 32-bit number in little-endian format. This is equivalent to REG_DWORD. 
 			  VALUE_TYPE_DWORD_BIG_ENDIAN=REG_DWORD_BIG_ENDIAN,				//A 32-bit number in big-endian format. 
			  VALUE_TYPE_LINK=REG_LINK,																//A Unicode symbolic link. Used internally; applications should not use this type. 
			  VALUE_TYPE_MULTI_SZ=REG_MULTI_SZ,												//An array of null-terminated strings, terminated by two null characters. 
			  VALUE_TYPE_RESOURCE_LIST=REG_RESOURCE_LIST,							//A device-driver resource list. 
 			  VALUE_TYPE_QWORD=REG_QWORD,															//A 64-bit number. 
			  VALUE_TYPE_QWORD_LITTLE_ENDIAN=REG_QWORD_LITTLE_ENDIAN  //A 64-bit number in little-endian format. This is equivalent to REG_QWORD. 
     };
    }
    namespace BASE_KEY
    {
      const HKEY HKCR=HKEY_CLASSES_ROOT;
      const HKEY HKCU=HKEY_CURRENT_USER;
      const HKEY HKLM=HKEY_LOCAL_MACHINE;
      const HKEY HKU=HKEY_USERS;
      const HKEY HKCC=HKEY_CURRENT_CONFIG;
      const HKEY HKPD=HKEY_PERFORMANCE_DATA;
      const HKEY HKDD=HKEY_DYN_DATA;
    }

		int OpenKey(							// Ouvre une clef de la base de registre et la cre si elle n'existe pas.
				    HKEY Base,										// Pointeur vers une clef de base
				    LPCTSTR KeyName,							// Chemin d'accs  partir de la clef de base
				    HKEY *KeyPtr,									// Pointeur vers la clefs ouverte
				    REGSAM Option);             	// OPTIONNEL option d'ouverture de la clef
         /* Renvoie ERROR_SUCCESS_CREATED si la clef  t cre, ERROR_SUCCESS_OPENED, si celle ci exisait dj, ERROR_SUCCESS_UNKNOWN si la fonction ne peut pas determiner la prexistance de la clef.
            En cas d'erreur, renvoie ERROR_FAILURE */
				    
    int WriteValue(          //Ecrit une valeur dans une clef dj ouverte. Ne se proccupe pas que la valeur existe ou non.
            HKEY KeyPtr,                  //Pointeur vers une clef dj ouverte
            LPCTSTR ValueName,            //Pointeur vers une chaine contenant le nom de la clef  crire
            REG_VALUE_TYPE::REG_VALUE_TYPE_ENUM Type,  //Type de la clef  crire
            CONST BYTE *Data,             //Donne de la clef
            uLONG DataLen);               //Optionnel (sauf exception) si non fournie, sera determin par le programme, si dsaccord, la fonction choue.
         /* Renvoie ERROR_NOERROR en cas de russite,
            ERROR_LEN_MISMATCH si la taille spcifi diffrente de 0 n'est pas la taille relle,
            ERROR_NEED_LEN si la taille doit tre spcifi (cas de VALUE_TYPE_BINARY, VALUE_TYPE_RESOURCE_LIST et VALUE_TYPE_NONE),
            ERROR_BAD_TYPE quand le type ne va pas,
            ERROR_TYPE_UNKNOWN si le type n'existe pas. */

    int DeleteValue(HKEY KeyPtr,LPCTSTR ValueName);
		void CloseKey(HKEY hKey);
		int CreateKey(HKEY Base, LPCTSTR KeyName);
		void DeleteKey(HKEY Base, LPCTSTR KeyName);
    int ReadValue(
            HKEY KeyPtr,
            LPCTSTR ValueName,
            REG_VALUE_TYPE::REG_VALUE_TYPE_ENUM *Type,
            LPBYTE Data,
            uLONG *DataLen);	// Lit une valeur numrique dans la base de registre
    /* Renvoie : */


    //Overloaded function
    int OpenKey(HKEY Base, LPCTSTR KeyName, HKEY *KeyPtr);
    int WriteValue(HKEY KeyPtr,LPCTSTR ValueName,char *Data); //Simplifie l'appel  la fonction prcdente.
    int WriteValue(HKEY KeyPtr,LPCTSTR ValueName,long *Data);   //Idem
    int WriteValue(HKEY KeyPtr,LPCTSTR ValueName,char *Data,bool expand);   //Idem
    int WriteValue(HKEY KeyPtr, LPCTSTR ValueName, REG_VALUE_TYPE::REG_VALUE_TYPE_ENUM Type, CONST BYTE *Data);
    int ReadValue(HKEY KeyPtr, LPCTSTR ValueName,long *Data);	// Ces deux fonctions renvoie ERROR_TYPE_MISMATCH si le type de la clef n'est aps celui sous entendu par l'appel  la fonction.
    int ReadValue(HKEY KeyPtr, LPCTSTR ValueName,char *Data,uLONG *Size);
  }
#endif
/********************************************************************
*                               UTILS                               *
*********************************************************************
  Fournit quelques fonctions htroclites. Elles sont l, car elles servent
par ailleur dans la bibliothque et je me suis dit que puiceque je les
avais crites, autant qu'elles soient exposes. */
#ifndef SECTIONPC_NOUTILS
	namespace Utils
	{
    void Swap(double &a,double &b);
    
#ifndef USING_DEVCPP
    //Ces fonctions ne sont pas disponible dans la version Dev C++

    /* Assez interesant, la chaine CMD doit tre une expression en VBS
       qui est interprt par msscript.ocx. */
    long ScriptEval(char *CMD,char *Sortie,long Len); //renvoie la longueur de la chaine Sortie (Len doit contenir la taille de la chaine sortie).
    void ScriptInit();    //DOIT tre appelle avant toute utilisation de ScriptEval (cet appel est assez long)
    void ScriptDeInit();  //DOIT tre appelle lorsque vous avez fini d'utiliser ScriptEval
    bool IsScriptInited();//Indique si le controle de Script est initialis ou non.

    const int RND_MAX=99999999;
		void RANDOMIZE(unsigned int Seed=0);      //Initialise le gnrateur de nombre alatoire
    double rnd();             //Renvoie un rel entre 0 et 1
    int RND(int Min,int Max); //Renvoie un entier entre Min et Max (compris) 
    int RND(int Max=RND_MAX+1); //Renvoie un entier entre 0 et Max-1 (compris) 
#endif
    
    namespace UNITS
    {
      enum longueur
      {
        metre,
        centimetre,
        millimetre,
        pouce,
        parsec,
        AL,
        UA,
        pied,
        USmille,
      };
      enum temperature
      {
        celsius,
        kelvin,
        farheneit,
        rankine
      };
    }
    double Conversion(double val,UNITS::longueur from,UNITS::longueur to);
    double Conversion(double val,UNITS::temperature from,UNITS::temperature to);

    //Cre un champ de bits.
    class SPBitTable
    {
      public:
        SPBitTable(long Size); // le champ va de 0  Size-1 (logique).
        ~SPBitTable();
        void Set();
        void Set(long Pos);
        void Clear();
        void Clear(long Pos);
        void Inv();
        void Inv(long Pos);
        bool Test(long Pos);

      private:
        SPINT32* table;
        long BitSize;
        long TableSize;
        char LastSize;
    };
	}
#endif
/********************************************************************
*                                Text                               *
*********************************************************************
   */
#ifndef SECTIONPC_NOTEXT
	namespace TextXP
	{
    namespace ADVIO
    {
      enum ColorAttribute
      {
        TEXTE_NOIR=0x00,
        TEXTE_BLEU=FOREGROUND_BLUE,
        TEXTE_VERT=FOREGROUND_GREEN,
        TEXTE_ROUGE=FOREGROUND_RED,
        TEXTE_CYAN=TEXTE_BLEU|TEXTE_VERT,
        TEXTE_MAGENTA=TEXTE_BLEU|TEXTE_ROUGE,
        TEXTE_JAUNE=TEXTE_VERT|TEXTE_ROUGE,
        TEXTE_GRIS=FOREGROUND_INTENSITY,
        TEXTE_BLANC=TEXTE_BLEU|TEXTE_VERT|TEXTE_ROUGE,
        TEXTE_BLEU_CLAIR=TEXTE_BLEU|TEXTE_GRIS,
        TEXTE_VERT_CLAIR=TEXTE_VERT|TEXTE_GRIS,
        TEXTE_ROUGE_CLAIR=TEXTE_ROUGE|TEXTE_GRIS,
        TEXTE_CYAN_CLAIR=TEXTE_CYAN|TEXTE_GRIS,
        TEXTE_MAGENTA_CLAIR=TEXTE_MAGENTA|TEXTE_GRIS,
        TEXTE_JAUNE_CLAIR=TEXTE_JAUNE|TEXTE_GRIS,
        TEXTE_BLANC_CLAIR=TEXTE_BLANC|TEXTE_GRIS,
        FOND_BLEU=BACKGROUND_BLUE,
        FOND_VERT=BACKGROUND_GREEN,
        FOND_ROUGE=BACKGROUND_RED,
        FOND_CYAN=FOND_BLEU|FOND_VERT,
        FOND_MAGENTA=FOND_BLEU|FOND_ROUGE,
        FOND_JAUNE=FOND_VERT|FOND_ROUGE,
        FOND_GRIS=BACKGROUND_INTENSITY, 
        FOND_BLANC=FOND_BLEU|FOND_VERT|FOND_ROUGE,
        FOND_BLEU_CLAIR=FOND_BLEU|FOND_GRIS,
        FOND_VERT_CLAIR=FOND_VERT|FOND_GRIS,
        FOND_ROUGE_CLAIR=FOND_ROUGE|FOND_GRIS,
        FOND_CYAN_CLAIR=FOND_CYAN|FOND_GRIS,
        FOND_MAGENTA_CLAIR=FOND_MAGENTA|FOND_GRIS,
        FOND_JAUNE_CLAIR=FOND_JAUNE|FOND_GRIS,
        FOND_BLANC_CLAIR=FOND_BLANC|FOND_GRIS
      };
    }
    class advio
    {
      public:

        advio();
        ~advio();
        advio& operator<<(const char *text);    //ecrit une chaine de caractre
        advio& operator<<(const char text);
        advio& operator<<(const int nb);    //ecrit une chaine de caractre
        advio& operator<<(const long nb);    //ecrit une chaine de caractre
        advio& operator<<(const __int64 nb); 
        advio& operator<<(const unsigned int nb);    //ecrit une chaine de caractre
        advio& operator<<(const unsigned long nb);    //ecrit une chaine de caractre
        advio& operator<<(const float nb);    //ecrit une chaine de caractre
        advio& operator<<(const double nb);    //ecrit une chaine de caractre
        advio& operator<<(const bool b);

        advio& operator>>(char* nb);    //ecrit une chaine de caractre
        advio& operator>>(char& text);
        advio& operator>>(long& nb);
        advio& operator>>(int& nb);
        advio& operator>>(double& nb);

        bool gotoxy(short int x,short int y);         //change la position du curseur
        bool SetColor(unsigned short c);                       //prend une combinaisone de ColorAttribute
        bool SetPos(short x1,short x2,short y1,short y2); //change les coordonn de la console
        bool SetTitle(char* Title);
        bool cls();
        bool pause(bool verbose=false);
        bool beep();
        advio& question(char *text);
        bool advio::SetHandler(BOOL(WINAPI &HandlerRoutine)(DWORD));
        bool HideCursor(bool Hide);

      private:
        void *InputHandle,*OutputHandle,*ConsoleInfo;
    };
    extern const char* crlf;
    extern const char* bip;
    extern const char* tab;
    //rajoutter \b (retour arrire) \f (saut de page) et \r (retour chariot)

	}
#endif
/********************************************************************
*                          LINEARALGEBRA                            *
*********************************************************************
  Encapsule des fonctions d'algbre linaire.
  Penser  dfinir la constante si vous voulez les utilisez. */
#ifdef SECTIONPC_USELINEAR
	namespace LinearAlgebra
	{
#include "SectionPC\LinearAlgebra.h"
	}
#endif
/********************************************************************
*                            ALGORITHME                             *
*********************************************************************
  Encapsule des fonctions d'algbre linaire.
  Penser  dfinir la constante si vous voulez les utilisez. */
#ifndef SECTIONPC_NOALGORITHME
	namespace Algorithme
	{
    template<class T> class STACK
    {
      public:
        void push(T);
        T pop();
        T top();
        STACK<T>& operator<<(T);  //push
        STACK<T>& operator>>(T&); //pop
        bool IsEmpty();
        STACK();
        ~STACK();
      private:
        STACK<T>* next;
        T* object;
    };
#include "SectionPC\Algorithme.h"
	}
#endif
/********************************************************************
*                                WIN32                              *
********************************************************************/
#ifndef SECTIONPC_NOWIN32
  namespace win32     //Quelques fonctions de l'API windows pour un appel plus simple.
  {
    namespace SPECIAL_FOLDER
    {
      const int DIR_ADMINTOOLS=CSIDL_ADMINTOOLS;                //Version 5.0. File system directory that is used to store administrative tools for an individual user. The Microsoft Management Console will save customized consoles to this directory, and it will roam with the user. 
      const int DIR_COMMON_ADMINTOOLS=CSIDL_COMMON_ADMINTOOLS;  //Version 5.0. File system directory containing containing administrative tools for all users of the computer. 
      const int DIR_APPDATA=CSIDL_APPDATA;                      //Version 4.71. File system directory that serves as a common repository for application-specific data. A typical path is C:\Documents and Settings\username\Application Data. This CSIDL is supported by the redistributable ShFolder.dll for systems that do not have the Internet Explorer 4.0 integrated Shell installed. 
      const int DIR_COMMON_APPDATA=CSIDL_COMMON_APPDATA;        //Version 5.0. Application data for all users. A typical path is C:\Documents and Settings\All Users\Application Data. 
      const int DIR_COMMON_DOCUMENTS=CSIDL_COMMON_DOCUMENTS;    //File system directory that contains documents that are common to all users. Typical paths are C:\Documents and Settings\All Users\Documents. Valid for Windows NT systems and Windows 95 and Windows 98 systems with Shfolder.dll installed. 
      const int DIR_COOKIES=CSIDL_COOKIES;                      //File system directory that serves as a common repository for Internet cookies. A typical path is C:\Documents and Settings\username\Cookies. 
      const int DIR_HISTORY=CSIDL_HISTORY;                      //File system directory that serves as a common repository for Internet history items. 
      const int DIR_INTERNET_CACHE=CSIDL_INTERNET_CACHE;        //Version 4.72. File system directory that serves as a common repository for temporary Internet files. A typical path is C:\Documents and Settings\username\Temporary Internet Files. 
      const int DIR_LOCAL_APPDATA=CSIDL_LOCAL_APPDATA;          //Version 5.0. File system directory that serves as a data repository for local (nonroaming) applications. A typical path is C:\Documents and Settings\username\Local Settings\Application Data. 
      const int DIR_MYPICTURES=CSIDL_MYPICTURES;                //Version 5.0. My Pictures folder. A typical path is C:\Documents and Settings\username\My Documents\My Pictures. 
      const int DIR_PERSONAL=CSIDL_PERSONAL;                    //File system directory that serves as a common repository for documents. A typical path is C:\Documents and Settings\username\My Documents. This should be distinguished from the virtual My Documents folder in the namespace. To access that virtual folder, use the technique described in Managing the File System. 
      const int DIR_PROGRAM_FILES=CSIDL_PROGRAM_FILES;          //Version 5.0. Program Files folder. A typical path is C:\Program Files. 
      const int DIR_PROGRAM_FILES_COMMON=CSIDL_PROGRAM_FILES_COMMON; //Version 5.0. A folder for components that are shared across applications. A typical path is C:\Program Files\Common. Valid only for Windows NT and Windows 2000 systems. 
      const int DIR_SYSTEM=CSIDL_SYSTEM;                        //Version 5.0. System folder. A typical path is C:\WINNT\SYSTEM32. 
      const int DIR_WINDOWS=CSIDL_WINDOWS;                      //Version 5.0. Windows directory or SYSROOT. This corresponds to the %windir% or %SYSTEMROOT% environment variables. A typical path is C:\WINNT. 

      const int DIR_ALTSTARTUP =CSIDL_ALTSTARTUP;               //File system directory that corresponds to the user's nonlocalized Startup program group. 
      const int DIR_BITBUCKET=CSIDL_BITBUCKET;                  //Virtual folder containing the objects in the user's Recycle Bin. 
      const int DIR_COMMON_ALTSTARTUP=CSIDL_COMMON_ALTSTARTUP;  //File system directory that corresponds to the nonlocalized Startup program group for all users. Valid only for Windows NT systems. 
      const int DIR_COMMON_DESKTOPDIRECTORY=CSIDL_COMMON_DESKTOPDIRECTORY; //File system directory that contains files and folders that appear on the desktop for all users. A typical path is C:\Documents and Settings\All Users\Desktop. Valid only for Windows NT systems. 
      const int DIR_COMMON_FAVORITES=CSIDL_COMMON_FAVORITES;    //File system directory that serves as a common repository for all users' favorite items. Valid only for Windows NT systems. 
      const int DIR_COMMON_PROGRAMS=CSIDL_COMMON_PROGRAMS;      //File system directory that contains the directories for the common program groups that appear on the Start menu for all users. A typical path is C:\Documents and Settings\All Users\Start Menu\Programs. Valid only for Windows NT systems. 
      const int DIR_COMMON_STARTMENU=CSIDL_COMMON_STARTMENU;    //File system directory that contains the programs and folders that appear on the Start menu for all users. A typical path is C:\Documents and Settings\All Users\Start Menu. Valid only for Windows NT systems. 
      const int DIR_COMMON_STARTUP=CSIDL_COMMON_STARTUP;        //File system directory that contains the programs that appear in the Startup folder for all users. A typical path is C:\Documents and Settings\All Users\Start Menu\Programs\Startup. Valid only for Windows NT systems. 
      const int DIR_COMMON_TEMPLATES=CSIDL_COMMON_TEMPLATES;    //File system directory that contains the templates that are available to all users. A typical path is C:\Documents and Settings\All Users\Templates. Valid only for Windows NT systems. 
      const int DIR_CONTROLS=CSIDL_CONTROLS;                    //Virtual folder containing icons for the Control Panel applications. 
      const int DIR_DESKTOP=CSIDL_DESKTOP;                      //Windows Desktopvirtual folder that is the root of the namespace. 
      const int DIR_DESKTOPDIRECTORY=CSIDL_DESKTOPDIRECTORY;    //File system directory used to physically store file objects on the desktop (not to be confused with the desktop folder itself). A typical path is C:\Documents and Settings\username\Desktop 
      const int DIR_DRIVES=CSIDL_DRIVES;                        //My Computervirtual folder containing everything on the local computer: storage devices, printers, and Control Panel. The folder may also contain mapped network drives. 
      const int DIR_FAVORITES=CSIDL_FAVORITES;                  //File system directory that serves as a common repository for the user's favorite items. A typical path is C:\Documents and Settings\username\Favorites. 
      const int DIR_FONTS=CSIDL_FONTS;                          //Virtual folder containing fonts. A typical path is C:\WINNT\Fonts. 
      const int DIR_INTERNET=CSIDL_INTERNET;                    //Virtual folder representing the Internet. 
      const int DIR_MYMUSIC=CSIDL_MYMUSIC;                      //File system directory that serves as a common repository for music files. A typical path is C:\My Music. 
      const int DIR_NETHOOD=CSIDL_NETHOOD;                      //A file system folder containing the link objects that may exist in the My Network Places virtual folder. It is not the same as CSIDL_NETWORK, which represents the network namespace root. A typical path is C:\Documents and Settings\username\NetHood. 
      const int DIR_NETWORK=CSIDL_NETWORK;                      //Network Neighborhoodvirtual folder representing the root of the network namespace hierarchy. 
      const int DIR_PRINTERS=CSIDL_PRINTERS;                    //Virtual folder containing installed printers. 
      const int DIR_PRINTHOOD=CSIDL_PRINTHOOD;                  //File system directory that contains the link objects that may exist in the Printers virtual folder. A typical path is C:\Documents and Settings\username\PrintHood. 
      const int DIR_PROFILE=CSIDL_PROFILE;                      //Version 5.0. User's profile folder. 
      const int DIR_PROGRAMS=CSIDL_PROGRAMS;                    //File system directory that contains the user's program groups (which are also file system directories). A typical path is C:\Documents and Settings\username\Start Menu\Programs. 
      const int DIR_RECENT=CSIDL_RECENT;                        //File system directory that contains the user's most recently used documents. A typical path is C:\Documents and Settings\username\Recent. To create a shortcut in this folder, use SHAddToRecentDocs. In addition to creating the shortcut, this function updates the Shell's list of recent documents and adds the shortcut to the Documents submenu of the Start menu. 
      const int DIR_SENDTO=CSIDL_SENDTO;                        //File system directory that contains Send To menu items. A typical path is C:\Documents and Settings\username\SendTo. 
      const int DIR_STARTMENU=CSIDL_STARTMENU;                  //File system directory containing Start menu items. A typical path is C:\Documents and Settings\username\Start Menu. 
      const int DIR_STARTUP=CSIDL_STARTUP;                      //File system directory that corresponds to the user's Startup program group. The system starts these programs whenever any user logs onto Windows NT or starts Windows 95. A typical path is C:\Documents and Settings\username\Start Menu\Programs\Startup. 
      const int DIR_TEMPLATES=CSIDL_TEMPLATES;                  //File system directory that serves as a common repository for document templates. 
    }
    namespace Chrono  //Permet une utilisation simple de QueryPerformanceFrequency et QueryPerformanceCounter
    {
      typedef SPINT64* CHRONO;
      CHRONO Start(void);
        /* Initialise un compteur. Le nombre renvoy doit tre utilis
           pour les appels ultrieur  Start et Query. Si la fonction 
           renvoie 0 c'est que l'appel a chou, le system ne supporte 
           peut-tre pas les compteurs de hautes prcisions. */
      double Stop(CHRONO);
        /* Renvoie le nombre de seconde coul depuis l'appel  la fonction
           Start et arrte le compteur. L'index du compteur ne peut plus
           tre utilis. Il est important pour acclerer le traitement
           d'utiliser Stop plutot que Query a chaque fois que c'est possible.*/
      double QueryS(CHRONO);
        /* Renvoie le nombre de seconde coul depuis l'appel  la fonction
           Start mais n'arrte pas le compteur et conserve sa rfrence. */
      int QueryM(CHRONO);
        /* Renvoie le nombre de milliseconde coul depuis l'appel  la fonction
           Start mais n'arrte pas le compteur et conserve sa rfrence. */
      double Query(CHRONO);
        /* Equivalent  QueryS gard pour retro-compatibilit */
    }
    namespace SHUTDOWN_TYPE
    {
      enum SHUTDOWN_TYPE
      {
        ETEINDRE,
        POWEROFF=ETEINDRE,
        UTILISATEUR,
        LOGOFF=UTILISATEUR,
        REDEMARRER,
        REBOOT=REDEMARRER,
        ANNULER,
        CANCEL=ANNULER
      };
    }
    void SendKeys(char *CMD,long WaitTime=0,bool Modal=true); //Ne fonctionne pas encore.
    bool GetDir(int Dir,char Path[MAX_PATH],bool Create=false);
    bool ShutDown(SHUTDOWN_TYPE::SHUTDOWN_TYPE reason,int timeout=0,bool force=false,char* comment=NULL);
  }
  #endif
}

#ifdef SECTIONPC_USE_ALL  //Dfnit automatiquement tout les namespace
  using namespace SectionPC;
  using namespace SectionPC::Ascii;
  using namespace SectionPC::Clipboard;
  using namespace SectionPC::Hash;
  #ifdef SECTIONPC_USELINEAR
    using namespace SectionPC::LinearAlgebra;
  #endif
  using namespace SectionPC::Math;
  using namespace SectionPC::Math::Fonctions;
  using namespace SectionPC::Math::Suite;
  using namespace SectionPC::Registry;
  using namespace SectionPC::TextXP;
  using namespace SectionPC::Utils;
  using namespace SectionPC::win32;
  using namespace SectionPC::win32::Chrono;
  extern advio spconsole;
#endif
#ifdef SECTIONPC_USE_DEFAULT  //Dfnit automatiquement les namespace les plus utiliss
#ifndef SECTIONPC_USE_ALL
  using namespace SectionPC;
  using namespace SectionPC::Hash;
  using namespace SectionPC::TextXP;
  using namespace SectionPC::Utils;
  using namespace SectionPC::win32::Chrono;
  extern advio spconsole;
#endif
#endif
#endif    //SECTIONPC
