template<class T,int n> class Matrice
{
  public:
    Matrice();
    Matrice(T Body[n][n]);
    ~Matrice();
    Matrice<T,n> operator+(const Matrice<T,n> &autre) const;
    Matrice<T,n> operator*(const Matrice<T,n> &autre) const;
    Matrice<T,n> operator-(const Matrice<T,n> &autre) const;
    Matrice<T,n> operator/(const Matrice<T,n> &autre) const;
    friend TextXP::advio& operator<<(TextXP::advio& s,const Matrice<T,n> &moi);
    friend TextXP::advio& operator>>(TextXP::advio& s,Matrice<T,n> &moi);
  private:
    T body[n][n];
};

/****************************************
*             CONSTRUCTEURS             *
****************************************/
template<class T,int n> Matrice<T,n>::Matrice()
{
}
template<class T,int n> Matrice<T,n>::Matrice(T Body[n][n])
{
  int i,j;
  for (i=0;i<n;i++)
    for (j=0;j<n;j++)
      body[i][j]=Body[i][j];
}
template<class T,int n> Matrice<T,n>::~Matrice()
{
}

/****************************************
*              OPERATEURS               *
****************************************/
template<class T,int n> Matrice<T,n> Matrice<T,n>::operator+(const Matrice<T,n> &autre) const
{
  T temp[n][n];
  int i,j;
  for (i=0;i<n;i++)
    for (j=0;j<n;j++)
      temp[i]=body[i][j]+autre.body[i][j];
  return Matrice<T,n>(temp);
}

template<class T,int n> Matrice<T,n> Matrice<T,n>::operator*(const Matrice<T,n> &autre) const
{
  T temp[n][n];
  int i,j;
  for (i=0;i<n;i++)
    for (j=0;j<n;j++)
      temp[i]=body[i][j]*autre.body[i][j];
  return Matrice<T,n>(temp);
}
template<class T,int n> Matrice<T,n> Matrice<T,n>::operator-(const Matrice<T,n> &autre) const
{
  T temp[n][n];
  int i,j;
  for (i=0;i<n;i++)
    for (j=0;j<n;j++)
      temp[i]=body[i][j]-autre.body[i][j];
  return Matrice<T,n>(temp);
}
template<class T,int n> Matrice<T,n> Matrice<T,n>::operator/(const Matrice<T,n> &autre) const
{
  T temp[n][n];
  int i,j;
  for (i=0;i<n;i++)
    for (j=0;j<n;j++)
      temp[i]=body[i][j]/autre.body[i][j];
  return Matrice<T,n>(temp);
}

template<class T,int n> TextXP::advio& operator<<(TextXP::advio& s,const Matrice<T,n> &moi)
{
  int i,j;
  for (i=0;i<n;i++)
  {
    for (j=0;j<n;j++)
    {
      s << moi.body[i][j];
      if (j+1<n) s << " ";
    }
    if (i+1<n) s << crlf;
  }
  return s;
}

template<class T,int n> TextXP::advio& operator>>(TextXP::advio& s,Matrice<T,n> &moi)
{
  int i,j;
  for (i=0;i<n;i++)
    for (j=0;j<n;j++)
      s >> moi.body[i][j];
  return s;
}
